'Thread de lectura para el puerto serie
Imports System.Threading
Public Class clsLector
    Private StatePort As Integer
    Private thrReading As Thread
    Private strLastReading As String
    Public Event NewReading()
    Public ReadOnly Property State() As Integer
        Get
            State = StatePort
        End Get
    End Property
    Public ReadOnly Property LastReading() As String
        Get
            LastReading = strLastReading
            strLastReading = ""
        End Get
    End Property
    Public Function PortOnOff(ByVal strCOM As String) As Integer
        Try
            If StatePort = 0 Then
                thrReading.Start()
                If modSerialPort.OpenPort(strCOM) = 1 Then
                    StatePort = 1
                End If
            ElseIf StatePort = 1 Then
                modSerialPort.ClosePort()
                StatePort = 2
            ElseIf StatePort = 2 Then
                If modSerialPort.OpenPort(strCOM) = 1 Then
                    StatePort = 1
                End If
            End If
            Return StatePort
        Catch
            Console.WriteLine(Err.Description)
            Return -1
        End Try
    End Function

    Private Sub thrTask()
        Dim Buffer(0 To 4) As Byte
        Do
            If StatePort = 1 Then
                modSerialPort.ReadPort(1, Buffer)
                SetText(oEnc.GetString(Buffer, 0, 1))
            End If
        Loop
    End Sub
    Private Sub SetText(ByVal text As String)
        If Asc(text) <> 13 Then
            strLastReading = strLastReading & text
        Else
            RaiseEvent NewReading()
        End If
    End Sub

    Protected Overrides Sub Finalize()
        If StatePort = 1 Then
            modSerialPort.ClosePort()
            StatePort = 2
        End If
        thrReading.Abort()
        thrReading = Nothing
        MyBase.Finalize()
    End Sub

    Public Sub New()
        StatePort = 0
        thrReading = New Thread(AddressOf thrTask)
        thrReading.IsBackground = True
    End Sub
End Class









