Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports Microsoft.VisualBasic

Imports System.IO
Imports System.Drawing.Imaging

Public Class frmSQLtest
    Private clsConn As clsDatos
    Private myReader As SqlDataReader
    Private WithEvents miLector As clsLector

    Private Sub frmSQLtest_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing

        With miLector
            If .State = 1 Then
                .PortOnOff("COM1:")
            End If
        End With
        miLector = Nothing
        myReader = Nothing

        clsConn.Disconnect()
        clsConn = Nothing

    End Sub

    Private Sub frmSQLtest_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Conexin a base de datos
        clsConn = New clsDatos
        'Connect2server devuelve verdadero si tuvo xito, y este valor 
        'lo toma setstatus para mostrarlo al usuario
        SetStatusBD(Connect2server("Contimovil", clsConn))

        'creacin de objeto lector
        miLector = New clsLector

        lblCom.Text = "Lector desactivado"
        lblCom.ForeColor = Color.Red

    End Sub
    Private Sub mnuServCh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuServCh.Click
        Dim newServer As String = InputBox("Ingrese el nombre del servidor SQL", "Especificar servidor SQL", "Contimovil")
        If newServer = "" Then Exit Sub
        clsConn.Disconnect()
        'Connect2server devuelve verdadero si tuvo xito, y este valor 
        'lo toma SetStatusBD para mostrarlo al usuario
        SetStatusBD(Connect2server(newServer, clsConn))
    End Sub
    Private Function Connect2server(ByVal strServer As String, ByRef oConn As clsDatos) As Boolean
        Dim strConn As String = "Data Source=" & strServer & ",1433;Initial Catalog=bdContinea;User Id=sa;Password=MagicCookie;"
        Return clsConn.connect(strConn)
    End Function
    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub
    Private Sub SetStatusBD(ByVal ok As Boolean)
        If ok Then
            pctBd.Visible = True
            pctNoBD.Visible = False
        Else
            pctBd.Visible = False
            pctNoBD.Visible = True
        End If
    End Sub

    Public Function ByteArrayToImage(ByVal bytImgData() As Byte, ByVal length As Integer) As Image
        Dim stmImgData As New MemoryStream(bytImgData)
        Dim bmp As Bitmap
        bmp = New Bitmap(stmImgData)
        ByteArrayToImage = Image.FromHbitmap(bmp.GetHbitmap)
    End Function

    Private Sub miLector_NewReading() Handles miLector.NewReading
        dbGetItem(miLector.LastReading)
    End Sub

    Private Sub mnuActLec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActLec.Click
        Dim strmsg As String = ""
        Dim ret As Integer

        With mnuActLec
            ret = miLector.PortOnOff("COM1:")
            If ret = 1 Then
                .Text = "Desactivar Lector"
                lblCom.ForeColor = Color.Green
                lblCom.Text = "Lector Activado"
            ElseIf ret = 2 Then
                .Text = "Activar Lector"
                lblCom.ForeColor = Color.Red
                lblCom.Text = "Lector desactivado"
            End If
        End With
    End Sub

    Private Sub dbGetItem(ByVal item As String)
        Try
            myReader = clsConn.Run("SELECT * FROM tablaprueba WHERE codigo='" & item & "'")

            If myReader.Read() Then
                Dim bytImgData() As Byte = _
                    myReader.GetSqlBinary(2)
                SetImg(ByteArrayToImage(bytImgData, bytImgData.Length))
                SetLbl(myReader.GetString(3), lblCodigo, Color.Black) 'Codigo
                SetTxt(myReader.GetString(1), txtDesc) 'Descripcin
                SetLbl(myReader.GetString(5), lblAutor, Color.Black) 'Autor
                SetLbl(myReader.GetString(4), lblISBN, Color.Black) 'ISBN
                SetLbl(myReader.GetString(6), lblTitulo, Color.Black) 'Titulo
                SetLbl(myReader.GetString(7), lblPrecio, Color.Black) 'Titulo
                SetLbl("Item encontrado", lblBD, Color.Green) 'Status
            Else
                SetLbl("Item no encontrado", lblBD, Color.Red) 'Status
            End If

            myReader.Close()
        Catch
            MsgBox(Err.Description)
            myReader.Close()
        End Try
    End Sub



    Delegate Sub SetImgCallback(ByVal img As System.Drawing.Image)
    Private Sub SetImg(ByVal img As System.Drawing.Image)
        ' InvokeRequired required compares the thread ID of the
        ' calling thread to the thread ID of the creating thread.
        ' If these threads are different, it returns true.
        If imagen1.InvokeRequired Then
            Dim d As New SetImgCallback(AddressOf SetImg)
            Me.Invoke(d, New Object() {img})
        Else
            Me.imagen1.Image = img
        End If
    End Sub

    Delegate Sub SetTxtCallback(ByVal text As String, ByRef otxt As TextBox)
    Private Sub SetTxt(ByVal text As String, ByRef otxt As TextBox)
        ' InvokeRequired required compares the thread ID of the
        ' calling thread to the thread ID of the creating thread.
        ' If these threads are different, it returns true.
        If otxt.InvokeRequired Then
            Dim d As New SetTxtCallback(AddressOf SetTxt)
            Invoke(d, New Object() {text, otxt})
        Else
            otxt.Text = text
        End If
    End Sub

    Delegate Sub SetLblCallback(ByVal text As String, ByRef olbl As Label, ByVal color As Color)
    Private Sub SetLbl(ByVal text As String, ByRef olbl As Label, ByVal color As Color)
        ' InvokeRequired required compares the thread ID of the
        ' calling thread to the thread ID of the creating thread.
        ' If these threads are different, it returns true.
        If olbl.InvokeRequired Then
            Dim d As New SetLblCallback(AddressOf SetLbl)
            Invoke(d, New Object() {text, olbl, color})
        Else
            With olbl
                .Text = text
                .ForeColor = color
            End With
        End If
    End Sub

End Class

